/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.Autobus;
import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import com.rjconsultores.ventaboletos.service.DiagramaAutobusService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderAutobus;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaAutobusController")
@Scope("prototype")
public class BusquedaAutobusController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<Autobus> plwAutobus;
    @Autowired
    private DiagramaAutobusService diagramaAutobusService;
    private MyListbox autobusList;
    private Paging pagingAutobus;
    private List<DiagramaAutobus> lsDiagramaAutobus;
    private Textbox txtNombre;
    private Combobox cmbDiagramaAutobus;

    public MyListbox getAutobusList() {
        return autobusList;
    }

    public void setAutobusList(MyListbox autobusList) {
        this.autobusList = autobusList;
    }

    public Combobox getCmbDiagramaAutobus() {
        return cmbDiagramaAutobus;
    }

    public void setCmbDiagramaAutobus(Combobox cmbDiagramaAutobus) {
        this.cmbDiagramaAutobus = cmbDiagramaAutobus;
    }

    public List<DiagramaAutobus> getLsDiagramaAutobus() {
        return lsDiagramaAutobus;
    }

    public void setLsDiagramaAutobus(List<DiagramaAutobus> lsDiagramaAutobus) {
        this.lsDiagramaAutobus = lsDiagramaAutobus;
    }

    public Paging getPagingAutobus() {
        return pagingAutobus;
    }

    public void setPagingAutobus(Paging pagingAutobus) {
        this.pagingAutobus = pagingAutobus;
    }

    public Textbox getTxtNombre() {
        return txtNombre;
    }

    public void setTxtNombre(Textbox txtNombre) {
        this.txtNombre = txtNombre;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verAutobus(new Autobus());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsDiagramaAutobus = diagramaAutobusService.obtenerTodos();
        super.doAfterCompose(comp);

        autobusList.setItemRenderer(new RenderAutobus());
        autobusList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                Autobus mr = (Autobus) autobusList.getSelected();
                verAutobus(mr);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verAutobus(Autobus ab) {
        if (ab == null) {
            return;
        }

        Map args = new HashMap();
        args.put("autobus", ab);
        args.put("autobusList", autobusList);

        openWindow("/gui/esquema_operacional/editarAutobus.zul",
                Labels.getLabel("editarAutobusController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<Autobus> autobusBusqueda =
                new HibernateSearchObject<Autobus>(Autobus.class, pagingAutobus.getPageSize());

        autobusBusqueda.addFilterEqual("activo", true);
        autobusBusqueda.addFilterLike("numautobus", "%" + txtNombre.getText().trim().concat("%"));

        Comboitem cbiDiagramaAutobus = cmbDiagramaAutobus.getSelectedItem();
        if (cbiDiagramaAutobus != null) {
            DiagramaAutobus dab = (DiagramaAutobus) cbiDiagramaAutobus.getValue();
            autobusBusqueda.addFilterEqual("diagramaAutobus", dab);
        }

        autobusBusqueda.addSortAsc("numautobus");

        plwAutobus.init(autobusBusqueda, autobusList, pagingAutobus);

        if (autobusList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaAutobusController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
